﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Reflection;
using System.IO;
using Infragistics.Windows.DataPresenter;
using AccuR2;

namespace gridTest
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    /// 
    public partial class Window1 : Window
    {
        class field
        {
            public string name;
            public string key;
            public int width;
            public int newWidth;
        }
        List<field>[] oldfields;
        List<field>[] newfields;
        List<field>[] mergefields;


        public Window1()
        {
            oldfields = new List<field>[6];
            oldfields[0] = new List<field>();
            oldfields[1] = new List<field>();
            oldfields[2] = new List<field>();
            oldfields[3] = new List<field>();
            oldfields[4] = new List<field>();
            oldfields[5] = new List<field>();

            newfields = new List<field>[6];
            newfields[0] = new List<field>();
            newfields[1] = new List<field>();
            newfields[2] = new List<field>();
            newfields[3] = new List<field>();
            newfields[4] = new List<field>();
            newfields[5] = new List<field>();

            mergefields = new List<field>[6];
            mergefields[0] = new List<field>();
            mergefields[1] = new List<field>();
            mergefields[2] = new List<field>();
            mergefields[3] = new List<field>();
            mergefields[4] = new List<field>();
            mergefields[5] = new List<field>();

            string strAppDir = System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName);

            String PersonalFolder =   Environment.GetFolderPath(Environment.SpecialFolder.Personal);

            InitializeComponent();

            mainAccDataContext db = new mainAccDataContext();
            var parQ = from x in db.BATs
                       select x;
            xamDataGrid1.DataSource= parQ;
        }

        private void save_Click(object sender, RoutedEventArgs e)
        {
            saveGridSetting(ref xamDataGrid1, this.Title);

        }

        private void load_Click(object sender, RoutedEventArgs e)
        {
            Window ss = new Mill.millSumSelect(true);
            ss.Show();
            //loadGridSettings(ref xamDataGrid1, this.Title);
        }
        public void saveGridSetting(ref XamDataGrid grid, string name)
        {
            name += ".xml";
            // get the old config from disk
            //get the old layouts 
            bool oldValid = false;
            foreach (var x in oldfields)
                x.Clear(); 
            foreach (var x in newfields)
                x.Clear();
            string oldWidthString="";
            string systemFolder = System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName) + "\\AccuR2widths\\";
            String PersonalFolder = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\AccuR2widths\\";

            //read from the user config- if failed get the system one
            try
            {
                StreamReader sr = new StreamReader(PersonalFolder+name);
                oldWidthString = sr.ReadToEnd();
                sr.Close();
            }
            catch
            {
                try
                {
                    StreamReader sr = new StreamReader(systemFolder + name);
                    oldWidthString = sr.ReadToEnd();
                    sr.Close();
                }
                catch { }
            }

            if (oldWidthString.Length > 0)
            {
                getFields(ref oldfields, oldWidthString);      //break it up
                oldValid = true;
            }

            bool newValid = false;
            //get the new layouts
            foreach (var x in newfields)
                x.Clear();
            try
            {
                string hh = grid.SaveCustomizations();
                if (hh.Length > 0)
                    getFields(ref newfields, hh);      //break it up
                newValid = true;
            }
            catch { }


            //write the layouts while merging the two sets- keep the ones with lengths
            string cust = this.xamDataGrid1.SaveCustomizations();
           
            FileStream fs = new FileStream(PersonalFolder+name, FileMode.Create, FileAccess.Write);
            StreamWriter sw = new StreamWriter(fs);

            mergeFields();
            sw.WriteLine("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
            sw.WriteLine("<xamDataPresenter version=\"8.2.20082.1002\">");
            sw.WriteLine("<fieldLayouts>");

            dumpFields(1, ref sw);

            sw.WriteLine("</fieldLayouts>");
            sw.WriteLine("</xamDataPresenter>");

            sw.Close();
        }
        private void mergeFields()//merge the data from the old and new
        {
            foreach (var x in mergefields)
                x.Clear();
            for (int x = 0; x < 6; x++)
            {
                int oldC = oldfields[x].Count;
                int newC = newfields[x].Count;
                int count = oldC > newC ? oldC : newC;
                for (int i = 0; i < count; i++)
                {
                    int length = 0;
                    string name = "";
                    string key = "";
                    try
                    {
                        name = newfields[x][i].name;
                    }
                    catch { }
                    if (name.Length == 0)
                        try
                        {
                            name = oldfields[x][i].name;
                        }
                        catch { }
                    try
                    {
                        length = newfields[x][i].width;
                    }
                    catch { }
                    if (length == 0)
                        try
                        {
                            length = oldfields[x][i].width;
                        }
                        catch { }
                    try
                    {
                        key = newfields[x][i].key;
                    }
                    catch { }
                    if (key.Length== 0)
                        try
                        {
                            key = oldfields[x][i].key;
                        }
                        catch { }
                    field ff = new field();
                    ff.name = name;
                    ff.key = key;
                    ff.width = length;
                    mergefields[x].Add(ff);
                }
            }
        }
        private void dumpFields(int index, ref StreamWriter sw)
        {
            //if there is nothing in the new- use the old
            //for (int x = 0; x < mergefields.Count(); x++)
            // %^&*()_ infragistics cant handle loading the child row if not opened
                for (int x = 0; x < 1; x++)
            {
                try
                {
                    if (mergefields[x].Count() > 0)
                    {
                        sw.WriteLine("<fieldLayout key=\"{0}\" >", mergefields[x][0].key);
                        sw.WriteLine("<fields>");

                        for (int i = 0; i < mergefields[x].Count(); i++)
                        {
                            int length = 0;
                            string name = "";
                            try
                            {
                                name = mergefields[x][i].name;
                            }
                            catch { }
                            try
                            {
                                length = mergefields[x][i].width;
                            }
                            catch { }
                            if (name.Length > 0)
                            {
                                if (length == 0)
                                    sw.WriteLine("<field name=\"{0}\" />", name);
                                else
                                    sw.WriteLine("<field name=\"{0}\" cellWidth=\"{1}\" labelWidth=\"{1}\"/>", name, length);
                            }
                        }
                        sw.WriteLine("</fields>");
                sw.WriteLine("</fieldLayout>");
                    }
                }
                catch { }
               
            }
        }
        public void loadGridSettings(ref XamDataGrid grid, string name)
        {
            name += ".xml";
            string systemFolder = System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName) + "\\AccuR2widths\\";
            String PersonalFolder = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\AccuR2widths\\";

            try
            {
                Directory.CreateDirectory(PersonalFolder);  //create if...
            }
            catch { } try
            {
                Directory.CreateDirectory(systemFolder);  //create if...
            }
            catch { }

            /*load from the user directory
             * if non existant load from the app directory*/
            try
            {
                //Load the layout from a stream  
                using (FileStream fs = new FileStream(PersonalFolder + name, FileMode.Open, FileAccess.Read))
                {
                    grid.LoadCustomizations(fs);
                }
            }
            catch {
                try
                {
                    //Load the layout from a stream  
                    using (FileStream fs = new FileStream(systemFolder + name, FileMode.Open, FileAccess.Read))
                    {
                        grid.LoadCustomizations(fs);
                    }
                }
                catch { }
            }


        }
        private void getFields(ref List<field>[] list, string config)
        {
            string[] oo = config.Split('<');
            int index = -1;
            string key = "";
            foreach (var x in oo)
            {
                string name = "";
                int length = 0;
                if (x.Contains("fieldLayout key"))
                {
                    index++;
                    string[] j = x.Split('"');
                    key = j[1];
                }
                if (x.Contains("field name"))
                {
                    string[] j = x.Split('"');
                    name = j[1];
                    try
                    {
                        length = int.Parse(j[3]);
                    }
                    catch
                    {
                        length = 0;
                    }
                    field i = new field();
                    i.width = length;
                    i.name = name;
                    i.key = key;
                    list[index].Add(i);
                }
            }
        } 
    }
}
